using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.ProductGroup.Cqrs;

public class GetProductGroupListResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetProductGroupListQuery() : IRequest<List<GetProductGroupListResponse>>;

public class GetProductGroupListHandler : IRequestHandler<GetProductGroupListQuery, List<GetProductGroupListResponse>>
{
    private readonly AppDbContext _context;

    public GetProductGroupListHandler(AppDbContext context) => _context = context;

    public async Task<List<GetProductGroupListResponse>> Handle(GetProductGroupListQuery request, CancellationToken cancellationToken)
    {
        return await _context.ProductGroup
            .AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new GetProductGroupListResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .ToListAsync(cancellationToken);
    }
}